#ifndef MONWIDGETGL_H
#define MONWIDGETGL_H

#include <QtOpenGL/QtOpenGL>

#include "lib3d/vec3.hpp"
#include "lib3d/vec2.hpp"

class monWidgetGL : public QGLWidget
{
    Q_OBJECT
public:
    monWidgetGL(QGLWidget *parent = 0);
    ~monWidgetGL();


    void afficher();
    void wireframe(bool est_actif);

protected:

    void initializeGL();
    void paintGL();
    void keyPressEvent(QKeyEvent *event);
    void timerEvent(QTimerEvent *event);

private:

    bool etat_affichage;


    std::vector<cpe::vec3> sommets;
    std::vector<cpe::vec2> uv_texture;

    std::vector<cpe::vec3> sommets_2;
    std::vector<cpe::vec3> sommets_2_originaux;

    unsigned int identifiant_texture;
    cpe::vec3 translation;
    double angle;

    unsigned int compteur_temps;

};

#endif // MONWIDGETGL_H
